package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetUniverseStargatesStargateIDParams creates a new GetUniverseStargatesStargateIDParams object
// with the default values initialized.
func NewGetUniverseStargatesStargateIDParams() *GetUniverseStargatesStargateIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseStargatesStargateIDParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetUniverseStargatesStargateIDParamsWithTimeout creates a new GetUniverseStargatesStargateIDParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetUniverseStargatesStargateIDParamsWithTimeout(timeout time.Duration) *GetUniverseStargatesStargateIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseStargatesStargateIDParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewGetUniverseStargatesStargateIDParamsWithContext creates a new GetUniverseStargatesStargateIDParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetUniverseStargatesStargateIDParamsWithContext(ctx context.Context) *GetUniverseStargatesStargateIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseStargatesStargateIDParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

/*GetUniverseStargatesStargateIDParams contains all the parameters to send to the API endpoint
for the get universe stargates stargate id operation typically these are written to a http.Request
*/
type GetUniverseStargatesStargateIDParams struct {

	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*StargateID
	  stargate_id integer

	*/
	StargateID int32

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get universe stargates stargate id params
func (o *GetUniverseStargatesStargateIDParams) WithTimeout(timeout time.Duration) *GetUniverseStargatesStargateIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get universe stargates stargate id params
func (o *GetUniverseStargatesStargateIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get universe stargates stargate id params
func (o *GetUniverseStargatesStargateIDParams) WithContext(ctx context.Context) *GetUniverseStargatesStargateIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get universe stargates stargate id params
func (o *GetUniverseStargatesStargateIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithDatasource adds the datasource to the get universe stargates stargate id params
func (o *GetUniverseStargatesStargateIDParams) WithDatasource(datasource *string) *GetUniverseStargatesStargateIDParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get universe stargates stargate id params
func (o *GetUniverseStargatesStargateIDParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithStargateID adds the stargateID to the get universe stargates stargate id params
func (o *GetUniverseStargatesStargateIDParams) WithStargateID(stargateID int32) *GetUniverseStargatesStargateIDParams {
	o.SetStargateID(stargateID)
	return o
}

// SetStargateID adds the stargateId to the get universe stargates stargate id params
func (o *GetUniverseStargatesStargateIDParams) SetStargateID(stargateID int32) {
	o.StargateID = stargateID
}

// WriteToRequest writes these params to a swagger request
func (o *GetUniverseStargatesStargateIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	// path param stargate_id
	if err := r.SetPathParam("stargate_id", swag.FormatInt32(o.StargateID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
